/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */
package JavaMicroBenchmark;


import java.util.*;


/**
 *
 * Java Micro Benchmark created a microbenchmark to test the performance of Java operations
 * on different platforms. Java Micro Benchmark can be used to guide optimization decisions
 * and to compare different Java implementations.
 *
 * @author: Yuriy Mikhaylovskiy  YuriyMikhaylovskiy@yahoo.com
 *
 *
 */

public class JavaMicroBenchmarkServer{
    private int number_of_processors = 1;
    private int number_of_count = 1000000000;
    private long number_of_time = 300000;
    private JavaMicroBenchmarkResult[][] mbmo;
    public String result_string = "";
    public double result_mflops = 0;
    public static boolean isTest = true;
    
    public JavaMicroBenchmarkServer(){

    }
    public String solve(){
        isTest = true;
        String st_res = "";
        double speed = 0;
		result_mflops=0;
        
        st_res = "";
        //st_res += SystemInfo()+"\n\n";
        Runtime rt = Runtime.getRuntime();
        rt.gc();
        number_of_processors = rt.availableProcessors();
        System.out.print("\nNumber of processors / threads:  "+number_of_processors+" / "+number_of_processors);
        st_res += "\nNumber of processors / threads:  "+number_of_processors+" / "+number_of_processors+"\n";
        System.out.println("\n*** Start Java Micro Benchmark Server ***");
        st_res += "\n*** Start Java Micro Benchmark Server ***\n";
        Thread[][] t = new Thread[7][number_of_processors];
        mbmo = new JavaMicroBenchmarkResult[7][number_of_processors];

        for(int i=0; i<number_of_processors; i++){
            try {
                t[0][i] = new Thread(""+i){
                    public void run() {
                        int j = Integer.parseInt(this.getName());
                        while(isTest){
                            JavaMicroBenchmarkIntArithmetic mbmint = new JavaMicroBenchmarkIntArithmetic();
                            mbmint.count = number_of_count;
                            System.out.println("+ Start new Thread JavaMicroBenchmarkIntArithmetic["+j+"]");
                            mbmint.solve();
                            if(!Double.isInfinite(((JavaMicroBenchmarkResult) mbmint).resultSpeed) && ((JavaMicroBenchmarkResult) mbmint).resultSpeed>0)
                            if(mbmo[0][j]==null)mbmo[0][j] = (JavaMicroBenchmarkResult) mbmint;
                            else{
                                mbmo[0][j].resultTime = ((JavaMicroBenchmarkResult) mbmint).resultTime;
                                mbmo[0][j].resultSpeed =  (mbmo[0][j].resultSpeed + ((JavaMicroBenchmarkResult) mbmint).resultSpeed) / 2f;
                                mbmo[0][j].resultInfo = "Int arithmetic operations per second: "+mbmo[0][j].resultSpeed+" E6";
                            }
                            try{
                                System.out.println("+ Result Thread ["+j+"] "+mbmo[0][j].resultInfo);
                            }catch(Exception ee){ System.out.println(ee.getMessage());}
                        }
                    }
                };
                t[1][i] = new Thread(""+i){
                    public void run() {
                        int j = Integer.parseInt(this.getName());
                        while(isTest){
                            JavaMicroBenchmarkLongArithmetic mbmlong = new JavaMicroBenchmarkLongArithmetic();
                            mbmlong.count = number_of_count;
                            System.out.println("+ Start new Thread JavaMicroBenchmarkLongArithmetic["+j+"]");
                            mbmlong.solve();
                            if(!Double.isInfinite(((JavaMicroBenchmarkResult) mbmlong).resultSpeed) && ((JavaMicroBenchmarkResult) mbmlong).resultSpeed>0)
                            if(mbmo[1][j]==null)mbmo[1][j] = (JavaMicroBenchmarkResult) mbmlong;
                            else{
                                mbmo[1][j].resultTime = ((JavaMicroBenchmarkResult) mbmlong).resultTime;
                                mbmo[1][j].resultSpeed =  (mbmo[1][j].resultSpeed + ((JavaMicroBenchmarkResult) mbmlong).resultSpeed) / 2f;
                                mbmo[1][j].resultInfo = "Long arithmetic operations per second: "+mbmo[1][j].resultSpeed+" E6";
                            }
                            try{
                                System.out.println("+ Result Thread ["+j+"] "+mbmo[1][j].resultInfo);
                            }catch(Exception ee){ System.out.println(ee.getMessage());}
                        }
                    }
                };
                t[2][i] = new Thread(""+i){
                    public void run() {
                        int j = Integer.parseInt(this.getName());
                        while(isTest){
                            JavaMicroBenchmarkDoubleArithmetic mbmdouble = new JavaMicroBenchmarkDoubleArithmetic();
                            mbmdouble.count = number_of_count;
                            System.out.println("+ Start new Thread JavaMicroBenchmarkDoubleArithmetic["+j+"]");
                            mbmdouble.solve();
                            if(!Double.isInfinite(((JavaMicroBenchmarkResult) mbmdouble).resultSpeed) && ((JavaMicroBenchmarkResult) mbmdouble).resultSpeed>0)
                            if(mbmo[2][j]==null)mbmo[2][j] = (JavaMicroBenchmarkResult) mbmdouble;
                            else{
                                mbmo[2][j].resultTime = ((JavaMicroBenchmarkResult) mbmdouble).resultTime;
                                mbmo[2][j].resultSpeed =  (mbmo[2][j].resultSpeed + ((JavaMicroBenchmarkResult) mbmdouble).resultSpeed) / 2f;
                                mbmo[2][j].resultInfo = "Double arithmetic operations per second: "+mbmo[2][j].resultSpeed+" E6";
                            }
                            try{
                                System.out.println("+ Result Thread ["+j+"] "+mbmo[2][j].resultInfo);
                            }catch(Exception ee){ System.out.println(ee.getMessage());}
                        }
                    }
                };
                t[3][i] = new Thread(""+i){
                    public void run() {
                        int j = Integer.parseInt(this.getName());
                        while(isTest){
                            JavaMicroBenchmarkTrigArithmetic mbmtrig = new JavaMicroBenchmarkTrigArithmetic();
                            mbmtrig.count = (int)(number_of_count/100);
                            System.out.println("+ Start new Thread JavaMicroBenchmarkTrigArithmetic["+j+"]");
                            mbmtrig.solve();
                            if(!Double.isInfinite(((JavaMicroBenchmarkResult) mbmtrig).resultSpeed) && ((JavaMicroBenchmarkResult) mbmtrig).resultSpeed>0)
                            if(mbmo[3][j]==null)mbmo[3][j] = (JavaMicroBenchmarkResult) mbmtrig;
                            else{
                                mbmo[3][j].resultTime = ((JavaMicroBenchmarkResult) mbmtrig).resultTime;
                                mbmo[3][j].resultSpeed =  (mbmo[3][j].resultSpeed + ((JavaMicroBenchmarkResult) mbmtrig).resultSpeed) / 2f;
                                mbmo[3][j].resultInfo = "Trig arithmetic operations per second: "+mbmo[3][j].resultSpeed+" E6";
                            }
                            try{
                                System.out.println("+ Result Thread ["+j+"] "+mbmo[3][j].resultInfo);
                            }catch(Exception ee){ System.out.println(ee.getMessage());}
                        }
                    }
                };
                t[4][i] = new Thread(""+i){
                    public void run() {
                        int j = Integer.parseInt(this.getName());
                        while(isTest){
                            JavaMicroBenchmarkCreateFile mbmcf = new JavaMicroBenchmarkCreateFile();
                            mbmcf.count = number_of_count/1000000;
                            System.out.println("+ Start new Thread JavaMicroBenchmarkCreateFile["+j+"]");
                            mbmcf.solve();
                            if(!Double.isInfinite(((JavaMicroBenchmarkResult) mbmcf).resultSpeed) && ((JavaMicroBenchmarkResult) mbmcf).resultSpeed>0)
                            if(mbmo[4][j]==null){
                                mbmo[4][j] = (JavaMicroBenchmarkResult) mbmcf;
                                mbmo[4][j].resultSpeed /= 10.0f;
                            }else{
                                mbmo[4][j].resultTime = ((JavaMicroBenchmarkResult) mbmcf).resultTime;
                                mbmo[4][j].resultSpeed =  (mbmo[4][j].resultSpeed + ((JavaMicroBenchmarkResult) mbmcf).resultSpeed / 10.0f) / 2f;
                                mbmo[4][j].resultInfo = "Created, deleted files per second: "+(mbmo[4][j].resultSpeed * 10.0f);
                            }
                            try{
                                System.out.println("+ Result Thread ["+j+"] "+mbmo[4][j].resultInfo);
                            }catch(Exception ee){ System.out.println(ee.getMessage());}
                        }
                    }
                };
                t[5][i] = new Thread(""+i){
                    public void run() {
                        int j = Integer.parseInt(this.getName());
                        while(isTest){
                            JavaMicroBenchmarkWriteFile mbmwf = new JavaMicroBenchmarkWriteFile();
                            mbmwf.count = number_of_count/5000;
                            System.out.println("+ Start new Thread JavaMicroBenchmarkWriteFile["+j+"]");
                            mbmwf.solve();
                            if(!Double.isInfinite(((JavaMicroBenchmarkResult) mbmwf).resultSpeed) && ((JavaMicroBenchmarkResult) mbmwf).resultSpeed>0)
                            if(mbmo[5][j]==null){
                                mbmo[5][j] = (JavaMicroBenchmarkResult) mbmwf;
                                mbmo[5][j].resultSpeed /= 10.0f;
                            }else{
                                mbmo[5][j].resultTime = ((JavaMicroBenchmarkResult) mbmwf).resultTime;
                                mbmo[5][j].resultSpeed =  (mbmo[5][j].resultSpeed + ((JavaMicroBenchmarkResult) mbmwf).resultSpeed / 10.0f) / 2f;
                                mbmo[5][j].resultInfo = "Write Mega Bytes per second: "+(mbmo[5][j].resultSpeed*10.0f);
                            }
                            try{
                                System.out.println("+ Result Thread ["+j+"] "+mbmo[5][j].resultInfo);
                            }catch(Exception ee){ System.out.println(ee.getMessage());}
                        }
                    }
                };
                t[6][i] = new Thread(""+i){
                    public void run() {
                        int j = Integer.parseInt(this.getName());
                        while(isTest){
                            JavaMicroBenchmarkReadFile mbmrf = new JavaMicroBenchmarkReadFile();
                            mbmrf.count = number_of_count/5000;
                            System.out.println("+ Start new Thread JavaMicroBenchmarkReadFile["+j+"]");
                            mbmrf.solve();
                            if(!Double.isInfinite(((JavaMicroBenchmarkResult) mbmrf).resultSpeed) && ((JavaMicroBenchmarkResult) mbmrf).resultSpeed>0)
                            if(mbmo[6][j]==null){
                                mbmo[6][j] = (JavaMicroBenchmarkResult) mbmrf;
                                mbmo[6][j].resultSpeed /= 10.0f;
                            }
                            else{
                                mbmo[6][j].resultTime = ((JavaMicroBenchmarkResult) mbmrf).resultTime;
                                mbmo[6][j].resultSpeed =  (mbmo[6][j].resultSpeed + ((JavaMicroBenchmarkResult) mbmrf).resultSpeed / 10.0f) / 2f;
                                mbmo[6][j].resultInfo = "Read Mega Bytes per second: "+(mbmo[6][j].resultSpeed*10.f);
                            }
                            try{
                                System.out.println("+ Result Thread ["+j+"] "+mbmo[6][j].resultInfo);
                            }catch(Exception ee){ System.out.println(ee.getMessage());}
                        }
                    }
                };



               
            } catch (Exception e) {System.out.println(e);}
        }
        System.out.println("\n+++ Start Thread +++");
        long TestTime = System.currentTimeMillis();
        for(int i=0; i<t.length; i++)
            for(int j=0; j<t[0].length; j++)
                t[i][j].start();
        try {
            Thread.sleep(number_of_time);
            isTest=false;
        }catch (Exception e) {System.out.println(e);}
        try {
            for(int i=0; i<t.length; i++)
                for(int j=0; j<t[0].length; j++)  t[i][j].join();
        }catch (Exception e) {System.out.println(e);}
        System.out.println("+++ End Thread +++\n");

        TestTime = System.currentTimeMillis() - TestTime;
        speed = 0;
        for(int i=0; i<number_of_processors; i++) {
            for(int j=0; j<mbmo.length; j++) {
                speed += mbmo[j][i].resultSpeed;
                System.out.println("Thread ("+i+") "+mbmo[j][i].resultInfo);
                st_res += "Thread ("+i+") "+mbmo[j][i].resultInfo+"\n";
            }
        }
        System.out.println("\nTime: "+TestTime+" ms");
        st_res += "\nTime: "+TestTime+" ms\n";
        System.out.println("Server: Index of overall performance: "+speed);
        st_res += "Server: Index of overall performance: "+speed+"\n";
        System.out.println("*** End Java Micro Benchmark Server ***\n");
        st_res += "*** End Java Micro Benchmark Server ***\n\n";
        result_string = st_res;
        result_mflops = speed;
        
        return st_res;
    }

    public double solve(int cnt, long tm){
        number_of_count = cnt;
        number_of_time = tm;
        solve();
        return result_mflops;
    }
    
    public String SystemInfo(){
      String st_res = "";
      try{
        Hashtable env = new Hashtable(System.getenv());
        for (Enumeration e = env.keys(); e.hasMoreElements();){
          Object key = e.nextElement();
          System.out.println(key+": "+env.get(key));
          st_res += key+": "+env.get(key)+"\n";
        }
      } catch (Exception e) {System.out.println(e);}
      try{
        Properties prop = System.getProperties();
        for (Enumeration e = prop.keys(); e.hasMoreElements();){
          Object key = e.nextElement();
          System.out.println(key+": "+prop.get(key));
          st_res += key+": "+prop.get(key)+"\n";
        }
      } catch (Exception e) {System.out.println(e);}
      return st_res;
  }
    
    public static void main(String[] args) {
        new JavaMicroBenchmarkServer().solve(1000000000,600000);
    }

}
