/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */

package JavaMicroBenchmark;
 
/**
 *
 * Java Micro Benchmark created a microbenchmark to test the performance of Java operations
 * on different platforms. Java Micro Benchmark can be used to guide optimization decisions
 * and to compare different Java implementations.
 *
 * @author: Yuriy Mikhaylovskiy  YuriyMikhaylovskiy@yahoo.com
 *
 *
 */

public class JavaMicroBenchmarkTrigArithmetic extends JavaMicroBenchmarkResult{
        public int count = 10000000;
		
	public void solve(int cnt){
            double sine = 0.0;
            double cosine = 0.0;
            double tangent = 0.0;
            double logarithm = 0.0;
            double squareRoot = 0.0;
            double i = 1;
            long startTime = System.currentTimeMillis();
            while (i < cnt){
		sine = Math.sin(i++);
		cosine = Math.cos(i++);
		tangent = Math.tan(i++);
		logarithm = Math.log(i++);
		squareRoot = Math.sqrt(i++);
            }
            resultTime = System.currentTimeMillis() - startTime;
            resultSpeed = (i/resultTime/1000);
            resultInfo = "Trig arithmetic operations per second: "+resultSpeed+" E6";
	}

        public void solve(){
            solve(count);
	}
	
	

	public static void main(String[] args)	{
            JavaMicroBenchmarkTrigArithmetic mbm = new JavaMicroBenchmarkTrigArithmetic();
            mbm.solve();
            System.out.println(mbm.resultInfo);
	}
}
